return {
  "neovim/nvim-lspconfig",
  dependencies = {
    {
      "hrsh7th/cmp-nvim-lsp",
    },
  },
  config = function () 
    local capabilities = require('cmp_nvim_lsp').default_capabilities()
    local on_attach = function (client, bufnr) 
      local lspSig = require('lsp_signature')
      local function buf_set_keymap(...) vim.api.nvim_buf_set_keymap(bufnr, ...) end
      local function buf_set_option(...) vim.api.nvim_buf_set_option(bufnr, ...) end

      lspSig.on_attach()

      -- enable completion triggered by <c-x><c-o>
      buf_set_option('omnifunc', 'v:lua.vim.lsp.omnifunc')

      -- mappings
      local opts = { noremap=true, silent=true }

      -- See `:help vim.lsp.*` for documentation on any of the below functions
      -- buf_set_keymap('n', 'gD', '<cmd>lua vim.lsp.buf.declaration()<CR>', opts)
      buf_set_keymap('n', '<leader>gd', '<cmd>lua vim.lsp.buf.definition()<CR>', opts)
      buf_set_keymap('n', '<leader>gt', '<cmd>tab split<CR><cmd>lua vim.lsp.buf.definition()<CR>', opts)
      buf_set_keymap('n', '<leader>gv', '<cmd>vsplit<CR><cmd>lua vim.lsp.buf.definition()<CR>', opts)
      buf_set_keymap('n', 'K', '<cmd>lua vim.lsp.buf.hover()<CR>', opts)
      buf_set_keymap('n', '<leader>gi', '<cmd>lua vim.lsp.buf.implementation()<CR>', opts)
      buf_set_keymap('n', '<C-k>', '<cmd>lua vim.lsp.buf.signature_help()<CR>', opts)
      -- buf_set_keymap('n', '<space>wa', '<cmd>lua vim.lsp.buf.add_workspace_folder()<CR>', opts)
      -- buf_set_keymap('n', '<space>wr', '<cmd>lua vim.lsp.buf.remove_workspace_folder()<CR>', opts)
      -- buf_set_keymap('n', '<space>wl', '<cmd>lua print(vim.inspect(vim.lsp.buf.list_workspace_folders()))<CR>', opts)
      buf_set_keymap('n', '<leader>D', '<cmd>lua vim.lsp.buf.type_definition()<CR>', opts)
      buf_set_keymap('n', '<leader>rn', '<cmd>lua vim.lsp.buf.rename()<CR>', opts)
      buf_set_keymap('n', '<leader>ca', '<cmd>lua vim.lsp.buf.code_action()<CR>', opts)
      buf_set_keymap('n', '<leader>gr', '<cmd>lua vim.lsp.buf.references()<CR>', opts)
      buf_set_keymap('n', '<leader>ge', '<cmd>lua vim.lsp.diagnostic.show_line_diagnostics()<CR>', opts)
      buf_set_keymap('n', '<leader>do', '<cmd>lua vim.lsp.diagnostic.open_float()<CR>', opts)
      buf_set_keymap('n', '<leader>d[', '<cmd>lua vim.lsp.diagnostic.goto_prev()<CR>', opts)
      buf_set_keymap('n', '<leader>d]', '<cmd>lua vim.lsp.diagnostic.goto_next()<CR>', opts)
      -- buf_set_keymap('n', '<space>q', '<cmd>lua vim.lsp.diagnostic.set_loclist()<CR>', opts)
      buf_set_keymap('n', '<leader>gf', '<cmd>lua vim.lsp.buf.format()<CR>', opts)
    end 

    
      vim.lsp.config('gopls', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('ts_ls', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('rust_analyzer', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('bashls', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('svelte', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('pylsp', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('zls', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('lua_ls', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('clangd', {
        capabilities = capabilities,
        on_attach = on_attach,
      })
      vim.lsp.config('pyright', {
        capabilities = capabilities,
        on_attach = on_attach,
      })

      vim.lsp.enable('gopls')
      vim.lsp.enable('ts_ls')
      vim.lsp.enable('rust_analyzer')
      vim.lsp.enable('bashls')
      vim.lsp.enable('svelte')
      vim.lsp.enable('pylsp')
      vim.lsp.enable('zls')
      vim.lsp.enable('lua_ls')
      vim.lsp.enable('clangd')
      vim.lsp.enable('pyright')

  end
}
